diff --git a/src/src/globals.h b/src/src/globals.h
index cb6b91c5a..ccd790cc2 100644
--- a/src/src/globals.h
+++ b/src/src/globals.h
@@ -40,10 +40,6 @@ extern BOOL    opt_perl_taintmode;     /* Enable taint mode in Perl */
 extern tree_node *dlobj_anchor;        /* Tree of dynamically-loaded objects */
 #endif
 
-#ifdef LOOKUP_IBASE
-extern uschar *ibase_servers;
-#endif
-
 #ifdef LOOKUP_LDAP
 extern uschar *eldap_ca_cert_dir;      /* Directory with CA certificates */
 extern uschar *eldap_ca_cert_file;     /* CA certificate file */
@@ -123,6 +119,7 @@ typedef struct {
   BOOL	  channelbind_exporter:1; /* channelbinding is EXPORTER not UNIQUE */
   BOOL    on_connect:1;         /* For older MTAs that don't STARTTLS */
   BOOL	  verify_override:1;	/* certificate_verified only due to tls_try_verify_hosts */
+  BOOL	  smtp_quit:1;		/* QUIT has been sent or received */
 } tls_support;
 extern tls_support tls_in;
 extern tls_support tls_out;
@@ -234,6 +231,7 @@ extern struct global_flags {
 
  BOOL   enable_dollar_recipients	:1; /* Make $recipients available */
  BOOL   expand_string_forcedfail	:1; /* TRUE if failure was "expected" */
+ BOOL   expansion_test			:1; /* TRUE for -be test mode */
 
  BOOL   filter_running			:1; /* TRUE while running a filter */
 
@@ -392,19 +390,19 @@ extern int     av_failed;              /* TRUE if the AV process failed */
 extern uschar *av_scanner;             /* AntiVirus scanner to use for the malware condition */
 #endif
 
+extern lookup_module_info * avail_static_lookups[];/* List of built-in lookup drivers */
+
+extern const uschar * avail_static_auths[];	/* List of built-in driver names */
+extern const uschar * avail_dynamic_auths[];	/* List of dynamic-load driver names */
+extern const uschar * avail_static_routers[];
+extern const uschar * avail_dynamic_routers[];
+extern const uschar * avail_static_transports[];
+extern const uschar * avail_dynamic_transports[];
+
 extern uschar *base62_chars;           /* Table of base-62 characters */
 extern uschar *bi_command;             /* Command for -bi option */
 extern uschar *big_buffer;             /* Used for various temp things */
 extern int     big_buffer_size;        /* Current size (can expand) */
-#ifdef EXPERIMENTAL_BRIGHTMAIL
-extern uschar *bmi_alt_location;       /* expansion variable that contains the alternate location for the rcpt (available during routing) */
-extern uschar *bmi_base64_tracker_verdict; /* expansion variable with base-64 encoded OLD verdict string (available during routing) */
-extern uschar *bmi_base64_verdict;     /* expansion variable with base-64 encoded verdict string (available during routing) */
-extern uschar *bmi_config_file;        /* Brightmail config file */
-extern int     bmi_deliver;            /* Flag that determines if the message should be delivered to the rcpt (available during routing) */
-extern int     bmi_run;                /* Flag that determines if message should be run through Brightmail server */
-extern uschar *bmi_verdicts;           /* BASE64-encoded verdicts with recipient lists */
-#endif
 extern int     bsmtp_transaction_linecount; /* Start of last transaction */
 extern int     body_8bitmime;          /* sender declared BODY= ; 7=7BIT, 8=8BITMIME */
 extern uschar *bounce_message_file;    /* Template file */
@@ -575,8 +573,6 @@ extern uschar *dnslist_value;          /* DNS (black) list IP address */
 extern tree_node *domainlist_anchor;   /* Tree of defined domain lists */
 extern int     domainlist_count;       /* Number defined */
 
-/* This option is now a no-opt, retained for compatibility */
-extern BOOL    drop_cr;                /* For broken local MUAs */
 extern const uschar *driver_srcfile;   /* For debug & errors */
 extern int     driver_srcline;	       /* For debug & errors */
 
@@ -923,8 +919,6 @@ extern int     retry_maximum_timeout;  /* The maximum timeout */
 extern const uschar *return_path;            /* Return path for a message */
 extern BOOL    return_path_remove;     /* Remove return-path headers */
 extern int     rewrite_existflags;     /* Indicate which headers have rewrites */
-extern uschar *rfc1413_hosts;          /* RFC hosts */
-extern int     rfc1413_query_timeout;  /* Timeout on RFC 1413 calls */
 /* extern BOOL    rfc821_domains;  */       /* If set, syntax is 821, not 822 => being abolished */
 extern uid_t   root_gid;               /* The gid for root */
 extern uid_t   root_uid;               /* The uid for root */
@@ -1065,7 +1059,6 @@ extern BOOL    system_filter_uid_set;  /* TRUE if uid set */
 extern blob    tcp_fastopen_nodata;    /* for zero-data TFO connect requests */
 extern BOOL    tcp_nodelay;            /* Controls TCP_NODELAY on daemon */
 extern tfo_state_t tcp_out_fastopen;   /* TCP fast open */
-extern int     test_harness_identd_port; /* For use when testing */
 extern int     test_harness_load_avg;  /* For use when testing */
 extern int     thismessage_size_limit; /* Limit for this message */
 extern int     timeout_frozen_after;   /* Max time to keep frozen messages */
diff --git a/src/src/local_scan.h b/src/src/local_scan.h
index a97fb4612..355487b0d 100644
--- a/src/src/local_scan.h
+++ b/src/src/local_scan.h
@@ -160,9 +160,6 @@ typedef struct recipient_item {
   const uschar *errors_to;      /* the errors_to address or NULL */
   uschar *orcpt;                /* DSN orcpt */
   int     dsn_flags;            /* DSN flags */
-#ifdef EXPERIMENTAL_BRIGHTMAIL
-  uschar *bmi_optin;
-#endif
 } recipient_item;
 
 
diff --git a/src/src/lookups/Makefile b/src/src/lookups/Makefile
index 74e705e37..d794fe895 100644
--- a/src/src/lookups/Makefile
+++ b/src/src/lookups/Makefile
@@ -8,17 +8,38 @@
 #     extra variable definitions and prepended to it and module build rules
 #     interpolated below. This is done by scripts/lookups-Makefile.
 
-# When adding a new driver here, attend also to scripts/lookups-Makefile
-# and scripts/MakeLinks
+# When adding a new driver here, attend also to scripts/lookups-Makefile,
+# and scripts/MakeLinks.
 
 # MAGIC-TAG-MODS-OBJ-RULES-GO-HERE
 
+OBJS = $(OBJ) $(OBJ_ALWAYS)
+
+# This assumes that the driver and object-file names match
+AVAIL= $(OBJS:.o=)
+
 all:             Makefile lookups.a $(MODS)
 
-lookups.a:       $(OBJ)
+# We assume here that the driver name is used as the prefix for
+# its module_info struct.
+avail_static_lookups.c: Makefile
+	@echo "make $@"
+	$(FE)echo '/* File built by lookups/Makefile */' >$@
+	$(FE)echo '#include "../exim.h"' >>$@
+	$(FE)for f in $(AVAIL); do \
+	 echo "extern lookup_module_info $${f}_lookup_module_info;" >>$@; \
+	done
+	$(FE)echo 'lookup_module_info * avail_static_lookups[] = {' >>$@
+	$(FE)for f in $(AVAIL); do \
+	 echo "& $${f}_lookup_module_info," >>$@; \
+	done
+	$(FE)echo 'NULL };' >>$@
+avail_static_lookups.o: $(HDRS) avail_static_lookups.c
+
+lookups.a:       avail_static_lookups.o $(OBJS)
 		 @$(RM_COMMAND) -f lookups.a
 		 @echo "$(AR) lookups.a"
-		 @$(AR) lookups.a $(OBJ)
+		 @$(AR) lookups.a avail_static_lookups.o $(OBJS)
 		 $(RANLIB) $@
 
 .SUFFIXES:       .o .c .so
@@ -32,7 +53,6 @@ cdb.o cdb.so:           $(HDRS) cdb.c
 dbmdb.o dbmdb.so:       $(HDRS) dbmdb.c
 dnsdb.o dnsdb.so:       $(HDRS) dnsdb.c
 dsearch.o dsearch.so:   $(HDRS) dsearch.c
-ibase.o ibase.so:       $(HDRS) ibase.c
 ldap.o ldap.so:         $(HDRS) ldap.c
 lmdb.o lmdb.so:         $(HDRS) lmdb.c
 json.o json.so:         $(HDRS) json.c
@@ -44,6 +64,7 @@ nmh.o nmh.so:		$(HDRS) nmh.c
 oracle.o oracle.so:     $(HDRS) oracle.c
 passwd.o passwd.so:     $(HDRS) passwd.c
 pgsql.o pgsql.so:       $(HDRS) pgsql.c
+psl.o psl.so:       	$(HDRS) psl.c
 readsock.o readsock.so: $(HDRS) readsock.c
 redis.o redis.so:       $(HDRS) redis.c
 spf.o spf.so:           $(HDRS) spf.c
diff --git a/src/src/lookups/psl.c b/src/src/lookups/psl.c
new file mode 100644
index 000000000..1592fe32d
--- /dev/null
+++ b/src/src/lookups/psl.c
@@ -0,0 +1,252 @@
+/*************************************************
+*     Exim - an Internet mail transport agent    *
+*************************************************/
+
+/* Copyright (c) The Exim Maintainers 2025 */
+/* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-or-later */
+
+#include "../exim.h"
+
+#ifndef SUPPORT_I18N
+# error PSL lookup requires internationalisation support
+#endif
+
+
+/*************************************************
+*              Open entry point                  *
+*************************************************/
+
+/* See local README for interface description */
+
+static void *
+psl_open(const uschar * filename, uschar ** errmsg)
+{
+FILE * f = fopen(CCS filename, "r");
+if (f) return (void *) f;
+*errmsg = US strerror(errno);
+return NULL;
+}
+
+static void
+psl_close(void * handle)
+{
+(void) fclose(handle);
+}
+
+
+
+
+/*************************************************
+*         Generic "find" implementation          *
+*************************************************/
+
+static int
+psl_gen_find(void * handle, const uschar * keystring,
+  int length, uschar ** result, uschar ** errmsg, BOOL is_regdom)
+{
+uschar rulebuf[128], * res = NULL;
+const uschar * s, * k, * kmatch;
+unsigned res_label_cnt = 0, nlabels;
+BOOL key_utf8;
+
+/* Ensure key is punycode and lowercase */
+
+if ((key_utf8 = string_is_utf8(keystring)))
+  {
+  DEBUG(D_lookup) debug_printf_indent("converting utf8 key %q\n", keystring);
+  if (!(keystring = string_domain_utf8_to_alabel(keystring, errmsg)))
+    return FAIL;
+  length = Ustrlen(keystring);
+  DEBUG(D_lookup) debug_printf_indent(" result %q\n", keystring);
+  }
+else
+  for (k = keystring; *k; k++)
+    if (isupper(*k)) { keystring = string_copylc(keystring); break; }
+
+while ((s = US fgets(CS rulebuf, sizeof(rulebuf), handle)))
+  {
+  const uschar * r;
+
+  if (!*s || *s == '\n') continue;		/* empty line */
+  if (s[0] == '/' && s[1] == '/') continue;	/* comment line */
+
+  nlabels = 1;
+  if ((r = US strsep(CSS &s, " \n\t")))
+    {
+    BOOL exception = *r == '!';
+    const uschar * t;
+
+    /* We convert any utf8 to punycode before starting comparison. It might
+    be more efficient to wait until hitting a top-bit-set byte? */
+    if (!(t = string_domain_utf8_to_alabel(r, errmsg)))
+      goto fail;
+    if (t != r)
+      {
+      DEBUG(D_lookup) debug_printf_indent("converting utf8 psl entry %q\n"
+	" result %q\n", r, t);
+      r = t;
+      }
+
+    for (s = r + Ustrlen(r), k = keystring + length; ; )
+      {
+      uschar rch = s[-1];
+
+      if (rch == '.')		/* label separator */
+	nlabels++;
+      if (rch == '*')		/* wildcard in rule (assume leading) */
+	{
+	/* take the current label from the key */
+	while (k > keystring && k[-1] != '.')
+	  k--;
+	s = k;
+	/* s is the match */
+	/* k is the key trail after the regdom. label */
+	/* nlabels describes k */
+	break;			/* - match */
+	}
+      if (rch == '!')		/* exception rule */
+	{
+	if (!is_regdom)
+	  /* Remove the LH label then treat as a match */
+	  while (TRUE)
+	    if (!*s || *s++ == '.') break;
+
+	/* s is the match, or the regdom */
+	/* nlabels don't care */
+	res = string_copy_taint(s, GET_UNTAINTED);
+	goto found;		/* ER's have priority; stop reading file */
+	}
+
+      s--; k--;
+
+      if (rch != *k)		/* character difference */
+	goto nonmatch;
+      if (k <= keystring && !exception)	/* ran out of key */
+	goto nonmatch;
+      if (s == r)		/* run out of rule */
+	if (k[-1] != '.')	/* key has prefix on rule */
+	  goto nonmatch;
+	else
+	  break;		/* out of rule: s is the match */
+      }
+
+    if (nlabels > res_label_cnt)
+      {				/* new longest match (by cnt of labels) */
+      res = string_copy_taint(s, GET_UNTAINTED);
+      res_label_cnt = nlabels;
+      kmatch = k;
+      }
+
+    nonmatch:
+    }
+  }
+    /* kmatch is the key trail after the regdom. label */
+    /* res_label_cnt describes kmatch */
+
+if (is_regdom && res)		/* prepend label from key to pub-suffix */
+  {
+  s = kmatch;
+  /* back up one label in key */
+  if (s-- <= keystring) goto fail;	/* there must ba a dot */
+  if (s-- <= keystring) goto fail;	/* there must ba at least one ch */
+  while (s > keystring && s[-1] != '.') s--;
+  res = string_sprintf("%.*s%s", (int)(kmatch - s), s, res);
+  }
+
+found:
+
+if (key_utf8 && res)
+  {
+  if (!(*result = string_domain_alabel_to_utf8(res, errmsg)))
+    goto fail;
+  DEBUG(D_lookup)
+    debug_printf_indent("utf8 converting result %q\n to %q\n", res, *result);
+  }
+else
+  *result = res;
+
+rewind(handle);
+return OK;
+
+fail:
+rewind(handle);
+return FAIL;
+}
+
+
+
+/*************************************************
+*  Find entry points for pub-suffix and regdom   *
+*************************************************/
+
+/* See local README for interface description */
+
+static int
+psl_find(void * handle, const uschar * filename, const uschar * keystring,
+  int length, uschar ** result, uschar ** errmsg, uint * do_cache,
+  const uschar * opts)
+{
+return psl_gen_find(handle, keystring, length, result, errmsg, FALSE);
+}
+
+static int
+regdom_find(void * handle, const uschar * filename, const uschar * keystring,
+  int length, uschar ** result, uschar ** errmsg, uint * do_cache,
+  const uschar * opts)
+{
+return psl_gen_find(handle, keystring, length, result, errmsg, TRUE);
+}
+
+
+
+
+/*************************************************
+*         Version reporting entry point          *
+*************************************************/
+
+/* See local README for interface description. */
+
+#include "../version.h"
+
+gstring *
+psl_version_report(gstring * g)
+{
+#ifdef DYNLOOKUP
+g = string_fmt_append(g, "Library version: psl: Exim version %s\n", EXIM_VERSION_STR);
+#endif
+return g;
+}
+
+static lookup_info psl_lookup_info = {
+  .name =	US"psl",		/* lookup name */
+  .type =	lookup_absfile,		/* lookup from file */
+  .open =	psl_open,		/* open function */
+  .check =	NULL,			/* no check function */
+  .find =	psl_find,		/* find function */
+  .close =	psl_close,		/* close function */
+  .tidy =	NULL,			/* no tidy function */
+  .quote =	NULL,			/* no quoting function */
+  .version_report = psl_version_report	/* version reporting */
+};
+
+static lookup_info regdom_lookup_info = {
+  .name =	US"regdom",		/* lookup name */
+  .type =	lookup_absfile,		/* lookup from file */
+  .open =	psl_open,		/* open function */
+  .check =	NULL,			/* no check function */
+  .find =	regdom_find,		/* find function */
+  .close =	psl_close,		/* close function */
+  .tidy =	NULL,			/* no tidy function */
+  .quote =	NULL,			/* no quoting function */
+  .version_report = NULL		/* no version reporting (redundant) */
+};
+
+#ifdef DYNLOOKUP
+#define psl_lookup_module_info _lookup_module_info
+#endif
+
+static lookup_info *_lookup_list[] = { &psl_lookup_info, &regdom_lookup_info };
+lookup_module_info psl_lookup_module_info = { LOOKUP_MODULE_INFO_MAGIC, _lookup_list, 2 };
+
+/* End of lookups/psl.c */
diff --git a/src/src/lookups/spf.c b/src/src/lookups/spf.c
index ac03983c2..e1931ca0f 100644
--- a/src/src/lookups/spf.c
+++ b/src/src/lookups/spf.c
@@ -15,13 +15,6 @@ of the License, or (at your option) any later version.
 */
 
 #include "../exim.h"
-
-#ifndef EXIM_HAVE_SPF
-static void dummy(int x);
-static void dummy2(int x) { dummy(x-1); }
-static void dummy(int x) { dummy2(x-1); }
-#else
-
 #include "lf_functions.h"
 
 #ifndef EXPERIMENTAL_SPF_PERL
@@ -119,4 +112,3 @@ static lookup_info spf_lookup_info = {
 static lookup_info *_lookup_list[] = { &spf_lookup_info };
 lookup_module_info spf_lookup_module_info = { LOOKUP_MODULE_INFO_MAGIC, _lookup_list, 1 };
 
-#endif /* EXIM_HAVE_SPF */
diff --git a/src/src/macro_predef.c b/src/src/macro_predef.c
index 48287131a..caa6bf7c3 100644
--- a/src/src/macro_predef.c
+++ b/src/src/macro_predef.c
@@ -8,7 +8,7 @@
 /* SPDX-License-Identifier: GPL-2.0-or-later */
 
 /* Create a static data structure with the predefined macros, to be
-included in the main Exim build */
+included in the main Exim build. Also, table for various drivers. */
 
 #include "exim.h"
 #include "macro_predef.h"
@@ -203,9 +203,6 @@ due to conflicts with other common macros. */
 #ifdef EXPERIMENTAL_ARC
   builtin_macro_create(US"_HAVE_ARC");
 #endif
-#ifdef EXPERIMENTAL_BRIGHTMAIL
-  builtin_macro_create(US"_HAVE_BRIGHTMAIL");
-#endif
 #ifdef SUPPORT_DANE
   builtin_macro_create(US"_HAVE_DANE");
 #endif
@@ -252,9 +249,6 @@ due to conflicts with other common macros. */
 #ifdef LOOKUP_DSEARCH
   builtin_macro_create(US"_HAVE_LOOKUP_DSEARCH");
 #endif
-#ifdef LOOKUP_IBASE
-  builtin_macro_create(US"_HAVE_LOOKUP_IBASE");
-#endif
 #ifdef LOOKUP_LMDB
   builtin_macro_create(US"_HAVE_LMDB");
   builtin_macro_create(US"_HAVE_LOOKUP_LMDB");
@@ -283,6 +277,10 @@ due to conflicts with other common macros. */
 #ifdef LOOKUP_PGSQL
   builtin_macro_create(US"_HAVE_LOOKUP_PGSQL");
 #endif
+#ifdef LOOKUP_PSL
+  builtin_macro_create(US"_HAVE_LOOKUP_PSL");
+  builtin_macro_create(US"_HAVE_LOOKUP_REGDOM");
+#endif
 #ifdef LOOKUP_REDIS
   builtin_macro_create(US"_HAVE_LOOKUP_REDIS");
 #endif
@@ -322,9 +320,6 @@ exp_features(void)
 #ifdef EXPERIMENTAL_ARC
   builtin_macro_create(US"_EXP_ARC");
 #endif
-#ifdef EXPERIMENTAL_BRIGHTMAIL
-  builtin_macro_create(US"_EXP_BMI");
-#endif
 #ifdef EXPERIMENTAL_DCC
   builtin_macro_create(US"_EXP_DCC");
 #endif
@@ -358,6 +353,41 @@ params_dkim();
 #endif
 }
 
+/******************************************************************************/
+static void
+avail_append(const driver_info * di)
+{
+const uschar * avail_string = di->avail_string;
+if (!avail_string) avail_string = di->driver_name;
+  printf(" US\"%s\",", avail_string);
+}
+
+static void
+avail_list(const driver_info * drtable, const uschar * tag,
+  const uschar * group, BOOL magic)
+{
+printf("const uschar * avail_%s_%s[] = {", group, tag);
+for (const driver_info * di = drtable; di; di = di->next)
+  if (!!di->dyn_magic == magic) avail_append(di);
+printf(" NULL};\n");
+}
+
+static void
+avail_drs(const driver_info * drtable, const uschar * tag)
+{
+avail_list(drtable, tag, US"static", FALSE);
+avail_list(drtable, tag, US"dynamic", TRUE);
+}
+
+static void
+avail(void)
+{
+avail_drs((driver_info *)auths_available, US"auths");
+avail_drs((driver_info *)routers_available, US"routers");
+avail_drs((driver_info *)transports_available, US"transports");
+}
+
+/******************************************************************************/
 
 int
 main(void)
@@ -368,8 +398,10 @@ exp_features();
 options();
 expansions();
 params();
-
 printf("macro_item * macros = &p%u;\n", mp_index-1);
 printf("macro_item * mlast = &p0;\n");
+
+avail();
+
 exit(0);
 }
diff --git a/src/src/macros.h b/src/src/macros.h
index 75563d86b..2e0efc9b8 100644
--- a/src/src/macros.h
+++ b/src/src/macros.h
@@ -90,10 +90,6 @@ don't make the file descriptors two-way. */
 #define pipe_read  0
 #define pipe_write 1
 
-/* The RFC 1413 ident port */
-
-#define IDENT_PORT 113
-
 /* A macro to simplify testing bits in lookup types */
 
 #define mac_islookup(li,b) ((li)->type & (b))
@@ -385,26 +381,25 @@ enum {
   DEBUG_BIT(filter),
   DEBUG_BIT(hints_lookup),
   DEBUG_BIT(host_lookup),
-  DEBUG_BIT(ident),
   DEBUG_BIT(interface),
   DEBUG_BIT(lists),
-  DEBUG_BIT(load),		/* 15 */
-  DEBUG_BIT(lookup),
+  DEBUG_BIT(load),
+  DEBUG_BIT(lookup),		/* 15 */
   DEBUG_BIT(memory),
   DEBUG_BIT(noutf8),
   DEBUG_BIT(pid),
   DEBUG_BIT(process_info),
   DEBUG_BIT(queue_run),
   DEBUG_BIT(receive),
-  DEBUG_BIT(resolver),		/* 23 */
-  DEBUG_BIT(retry),
+  DEBUG_BIT(resolver),
+  DEBUG_BIT(retry),		/* 23 */
   DEBUG_BIT(rewrite),
   DEBUG_BIT(route),
   DEBUG_BIT(timestamp),
   DEBUG_BIT(tls),
   DEBUG_BIT(transport),
   DEBUG_BIT(uid),
-  DEBUG_BIT(verify),		/* 31 */
+  DEBUG_BIT(verify),		/* 30 - one spare! */
 };
 
 /* Multi-bit debug masks */
@@ -474,7 +469,6 @@ enum logbit {
   Li_dkim,
   Li_dkim_verbose,
   Li_dnssec,
-  Li_ident_timeout,
   Li_incoming_interface,
   Li_incoming_port,
   Li_millisec,
diff --git a/src/src/queue.c b/src/src/queue.c
index b3d972f41..97238ba1a 100644
--- a/src/src/queue.c
+++ b/src/src/queue.c
@@ -351,7 +351,8 @@ Returns:     nothing
 */
 
 void
-queue_run(qrunner * q, const uschar * start_id, const uschar * stop_id, BOOL recurse)
+queue_run(qrunner * q, const uschar * start_id, const uschar * stop_id,
+  BOOL recurse)
 {
 BOOL force_delivery = q->queue_run_force
   || deliver_selectstring || deliver_selectstring_sender;
@@ -519,6 +520,10 @@ for (int i = queue_run_in_order ? -1 : 0;
 #endif
 	      nelem(qpid) - 1])
 	{		/* The child table is maxed out; wait for the oldest */
+			/*XXX It might be nicer to wait for the first one
+			that happens to complete. */
+	set_process_info("running queue (ph 1): parallel limit %u",
+			nelem(qpid));
 	DEBUG(D_queue_run)
 	  debug_printf("q2stage waiting for child %d\n", (int)qpid[0]);
 	waitpid(qpid[0], NULL, 0);
@@ -799,15 +804,20 @@ turned off. */
 
 if (q->queue_2stage)
   {
+  unsigned active;
+  for (active = 0; active < nelem(qpid); active++)
+    if (!qpid[active]) { --active; break; }
 
-  /* wait for last children */
-  for (int i = 0; i < nelem(qpid); i++)
+  /* wait for all first-stage children */
+  for (unsigned i = 0; i < nelem(qpid); i++)
     if (qpid[i])
       {
-      DEBUG(D_queue_run) debug_printf("q2stage reaped child %d\n", (int)qpid[i]);
+      set_process_info("running queue (ph 1): wait-all, child %u/%u",
+		      i+1, active);
       waitpid(qpid[i], NULL, 0);
+      DEBUG(D_queue_run) debug_printf("q2stage reaped child %d\n", (int)qpid[i]);
       }
-    else break;
+    else break;		/* should be no holes in table, so we're done */
 
 #ifdef MEASURE_TIMING
   report_time_since(&timestamp_startup, US"queue_run phase 1 done");
diff --git a/src/src/readconf.c b/src/src/readconf.c
index cec89f9bb..f4da20b6a 100644
--- a/src/src/readconf.c
+++ b/src/src/readconf.c
@@ -79,9 +79,6 @@ static optionlist optionlist_config[] = {
   { "av_scanner",               opt_stringptr,   {&av_scanner} },
 #endif
   { "bi_command",               opt_stringptr,   {&bi_command} },
-#ifdef EXPERIMENTAL_BRIGHTMAIL
-  { "bmi_config_file",          opt_stringptr,   {&bmi_config_file} },
-#endif
   { "bounce_message_file",      opt_stringptr,   {&bounce_message_file} },
   { "bounce_message_text",      opt_stringptr,   {&bounce_message_text} },
   { "bounce_return_body",       opt_bool,        {&bounce_return_body} },
@@ -143,9 +140,6 @@ static optionlist optionlist_config[] = {
   { "dns_retry",                opt_int,         {&dns_retry} },
   { "dns_trust_aa",             opt_stringptr,   {&dns_trust_aa} },
   { "dns_use_edns0",            opt_int,         {&dns_use_edns0} },
- /* This option is now a no-op, retained for compatibility */
-  { "drop_cr",                  opt_bool,        {&drop_cr} },
-/*********************************************************/
   { "dsn_advertise_hosts",      opt_stringptr,   {&dsn_advertise_hosts} },
   { "dsn_from",                 opt_stringptr,   {&dsn_from} },
   { "envelope_to_remove",       opt_bool,        {&envelope_to_remove} },
@@ -191,9 +185,6 @@ static optionlist optionlist_config[] = {
   { "hosts_treat_as_local",     opt_stringptr,   {&hosts_treat_as_local} },
 #ifdef EXPERIMENTAL_XCLIENT
   { "hosts_xclient",		opt_stringptr,	 {&hosts_xclient} },
-#endif
-#ifdef LOOKUP_IBASE
-  { "ibase_servers",            opt_stringptr,   {&ibase_servers} },
 #endif
   { "ignore_bounce_errors_after", opt_time,      {&ignore_bounce_errors_after} },
   { "ignore_fromline_hosts",    opt_stringptr,   {&ignore_fromline_hosts} },
@@ -307,9 +298,6 @@ static optionlist optionlist_config[] = {
   { "retry_interval_max",       opt_time,        {&retry_interval_max} },
   { "return_path_remove",       opt_bool,        {&return_path_remove} },
   { "return_size_limit",        opt_mkint|opt_hidden, {&bounce_return_size_limit} },
-  { "rfc1413_hosts",            opt_stringptr,   {&rfc1413_hosts} },
-  { "rfc1413_port",		opt_int|opt_hidden, {&test_harness_identd_port} },
-  { "rfc1413_query_timeout",    opt_time,        {&rfc1413_query_timeout} },
   { "sender_unqualified_hosts", opt_stringptr,   {&sender_unqualified_hosts} },
   { "slow_lookup_log",          opt_int,         {&slow_lookup_log} },
   { "smtp_accept_keepalive",    opt_bool,        {&smtp_accept_keepalive} },
@@ -987,8 +975,13 @@ if (*s) for (macro_item * m = *s == '_' ? macros : macros_user; m; m = m->next)
     {
     int moveby;
 
-    EARLY_DEBUG(D_any, "%s: matched '%s' in '%.*s'\n", __FUNCTION__,
-      m->name, (int) Ustrlen(ss)-1, ss);
+    DEBUG(D_any)
+      if (f.expansion_test)
+	printf("macro '%s' -> '%s'\n", m->name, m->replacement);
+      else
+	EARLY_DEBUG(D_any, "%s: matched '%s' in '%.*s'\n", __FUNCTION__,
+	  m->name, (int) Ustrlen(ss)-1, ss);
+
     /* Expand the buffer if necessary */
 
     while (*newlen - m->namelen + m->replen + 1 > big_buffer_size)
@@ -3824,13 +3817,12 @@ for (di = *info_anchor; di; di = di->next)
 /* Potentially a loadable module. Look for a file with the right name. */
 
 if (!(dd = exim_opendir(CUS LOOKUP_MODULE_DIR)))
-  {
   log_write(0, LOG_MAIN|LOG_PANIC,
-	    "Couldn't open %s: not loading driver modules\n", LOOKUP_MODULE_DIR);
-  }
+	  "Couldn't open %s: not loading driver modules\n", LOOKUP_MODULE_DIR);
 else
   {
-  uschar * fname = string_sprintf("%s_%s." DYNLIB_FN_EXT, d->driver_name, class), * sname;
+  uschar * fname = string_sprintf("%s_%s." DYNLIB_FN_EXT,
+				  d->driver_name, class);
   const char * errormsg;
 
   DEBUG(D_any) debug_printf("Loading %s %s driver from %s\n",
diff --git a/src/src/receive.c b/src/src/receive.c
index 9d8bfa89c..cde09c40a 100644
--- a/src/src/receive.c
+++ b/src/src/receive.c
@@ -533,11 +533,6 @@ if (recipients_count >= recipients_list_max)
 
 recipients_list[recipients_count].address = recipient;
 recipients_list[recipients_count].pno = pno;
-#ifdef EXPERIMENTAL_BRIGHTMAIL
-recipients_list[recipients_count].bmi_optin = bmi_current_optin;
-/* reset optin string pointer for next recipient */
-bmi_current_optin = NULL;
-#endif
 recipients_list[recipients_count].orcpt = NULL;
 recipients_list[recipients_count].dsn_flags = 0;
 recipients_list[recipients_count++].errors_to = NULL;
@@ -3982,14 +3977,6 @@ if (fake_response != OK)
 
 f.deliver_firsttime = TRUE;
 
-#ifdef EXPERIMENTAL_BRIGHTMAIL
-if (bmi_run == 1)
-  { /* rewind data file */
-  lseek(data_fd, (long int)spool_data_start_offset(message_id), SEEK_SET);
-  bmi_verdicts = bmi_process_message(header_list, data_fd);
-  }
-#endif
-
 /* Update the timestamp in our Received: header to account for any time taken by
 an ACL or by local_scan(). The new time is the time that all reception
 processing is complete. */
diff --git a/src/src/route.c b/src/src/route.c
index 534198a85..778e524c1 100644
--- a/src/src/route.c
+++ b/src/src/route.c
@@ -35,16 +35,6 @@ optionlist optionlist_routers[] = {
                  LOFF(address_data) },
   { "address_test",       opt_bool|opt_public,
                  LOFF(address_test) },
-#ifdef EXPERIMENTAL_BRIGHTMAIL
-  { "bmi_deliver_alternate",   opt_bool | opt_public,
-                 LOFF(bmi_deliver_alternate) },
-  { "bmi_deliver_default",   opt_bool | opt_public,
-                 LOFF(bmi_deliver_default) },
-  { "bmi_dont_deliver",   opt_bool | opt_public,
-                 LOFF(bmi_dont_deliver) },
-  { "bmi_rule",           opt_stringptr|opt_public,
-                 LOFF(bmi_rule) },
-#endif
   { "cannot_route_message", opt_stringptr | opt_public,
                  LOFF(cannot_route_message) },
   { "caseful_local_part", opt_bool | opt_public,
@@ -1095,48 +1085,6 @@ if (r->condition)
     }
   }
 
-#ifdef EXPERIMENTAL_BRIGHTMAIL
-/* check if a specific Brightmail AntiSpam rule fired on the message */
-if (r->bmi_rule)
-  {
-  DEBUG(D_route) debug_printf_indent("checking bmi_rule\n");
-  if (bmi_check_rule(bmi_base64_verdict, r->bmi_rule) == 0)
-    {    /* none of the rules fired */
-    DEBUG(D_route)
-      debug_printf_indent("%s router skipped: none of bmi_rule rules fired\n", rname);
-    return SKIP;
-    }
-  }
-
-/* check if message should not be delivered */
-if (r->bmi_dont_deliver && bmi_deliver == 1)
-  {
-  DEBUG(D_route)
-    debug_printf_indent("%s router skipped: bmi_dont_deliver is FALSE\n", rname);
-  return SKIP;
-  }
-
-/* check if message should go to an alternate location */
-if (  r->bmi_deliver_alternate
-   && (bmi_deliver == 0 || !bmi_alt_location)
-   )
-  {
-  DEBUG(D_route)
-    debug_printf_indent("%s router skipped: bmi_deliver_alternate is FALSE\n", rname);
-  return SKIP;
-  }
-
-/* check if message should go to default location */
-if (  r->bmi_deliver_default
-   && (bmi_deliver == 0 || bmi_alt_location)
-   )
-  {
-  DEBUG(D_route)
-    debug_printf_indent("%s router skipped: bmi_deliver_default is FALSE\n", rname);
-  return SKIP;
-  }
-#endif
-
 /* All the checks passed. */
 
 return OK;
diff --git a/src/src/routers/accept.c b/src/src/routers/accept.c
index 09992b85f..9986c39aa 100644
--- a/src/src/routers/accept.c
+++ b/src/src/routers/accept.c
@@ -156,7 +156,7 @@ router_info accept_router_info =
   .options_block =	&accept_router_option_defaults,
   .options_len =	sizeof(accept_router_options_block),
   .init =		accept_router_init,
-# ifdef DYNLOOKUP
+# if ROUTER_ACCEPT==2
   .dyn_magic =		ROUTER_MAGIC,
 # endif
   },
diff --git a/src/src/routers/dnslookup.c b/src/src/routers/dnslookup.c
index 97e273dca..5df6ea8f9 100644
--- a/src/src/routers/dnslookup.c
+++ b/src/src/routers/dnslookup.c
@@ -484,7 +484,7 @@ router_info dnslookup_router_info =
   .options_block =	&dnslookup_router_option_defaults,
   .options_len =	sizeof(dnslookup_router_options_block),
   .init =		dnslookup_router_init,
-# ifdef DYNLOOKUP
+# if ROUTER_DNSLOOKUP==2
   .dyn_magic =		ROUTER_MAGIC,
 # endif
   },
diff --git a/src/src/routers/ipliteral.c b/src/src/routers/ipliteral.c
index 9052f2d48..022592c9e 100644
--- a/src/src/routers/ipliteral.c
+++ b/src/src/routers/ipliteral.c
@@ -218,7 +218,7 @@ router_info ipliteral_router_info =
   .options_block =	&ipliteral_router_option_defaults,
   .options_len =	sizeof(ipliteral_router_options_block),
   .init =		ipliteral_router_init,
-# ifdef DYNLOOKUP
+# if ROUTER_IPLITERAL==2
   .dyn_magic =		ROUTER_MAGIC,
 # endif
   },
diff --git a/src/src/routers/iplookup.c b/src/src/routers/iplookup.c
index 1f3945bc8..5d9c04d71 100644
--- a/src/src/routers/iplookup.c
+++ b/src/src/routers/iplookup.c
@@ -433,7 +433,7 @@ router_info iplookup_router_info =
   .options_block =	&iplookup_router_option_defaults,
   .options_len =	sizeof(iplookup_router_options_block),
   .init =		iplookup_router_init,
-# ifdef DYNLOOKUP
+# if ROUTER_IPLOOKUP==2
   .dyn_magic =		ROUTER_MAGIC,
 # endif
   },
diff --git a/src/src/routers/manualroute.c b/src/src/routers/manualroute.c
index 5a4c72bb0..589db7ead 100644
--- a/src/src/routers/manualroute.c
+++ b/src/src/routers/manualroute.c
@@ -517,7 +517,7 @@ router_info manualroute_router_info =
   .options_block =	&manualroute_router_option_defaults,
   .options_len =	sizeof(manualroute_router_options_block),
   .init =		manualroute_router_init,
-# ifdef DYNLOOKUP
+# if ROUTER_MANUALROUTE==2
   .dyn_magic =		ROUTER_MAGIC,
 # endif
   },
diff --git a/src/src/routers/queryprogram.c b/src/src/routers/queryprogram.c
index 92a2524ab..3e12ec0d7 100644
--- a/src/src/routers/queryprogram.c
+++ b/src/src/routers/queryprogram.c
@@ -549,7 +549,7 @@ router_info queryprogram_router_info =
   .options_block =    &queryprogram_router_option_defaults,
   .options_len =      sizeof(queryprogram_router_options_block),
   .init =             queryprogram_router_init,
-# ifdef DYNLOOKUP
+# if ROUTER_QUERYPROGRAM==2
   .dyn_magic =	      ROUTER_MAGIC,
 # endif
   },
